Leetcode: Data Structure and Algorithms

Binary Search
Linear Search
Sort
BFS
Dynamical Programming
All the solutions are from NeetCode channel on YouTube
Author

Rafiq Islam

Array

Say, we are given two sets \(A=[2,3,5,6,8]\) and \(B=[4,6,8]\). We want to find the intersection of the elements in these sets.

def intersection_of_two_sets(A,B):
  set_a = set(A)
  return [b for b in B if b in set_a]

A = [2,3,5,6,8]
B = [4,6,8]
print(intersection_of_two_sets(A,B))

[6, 8]

Say, we are given an array \(A=[1,2,2,3,3,3,4,4,4,4,5,5,5,5,5]\) and number of bins. We want to

def generate_histogram(A, num_bins):
  min_value = min(A)
  max_value = max(A)
  bin_width = (max_value-min_value)/num_bins

String

Given two strings s and t, return true if t is an anagram of s, and false otherwise

Example: Input: s="anagram", t="nagaram" Output: true

Since the word anagram has 3 a’s, 1 n, 1 g, 1 r, and 1 m and nagaram has exactly the same number of the same alphabets, therefore they are anagram of each other.

Example: Input: s="rat", t="cat" Output: false

Since the word rat has 1 r, 1 a, and 1 t but cat has 2 elements same as rat but one element different. Therefore the answer is false.

Note that, they both have the same length.

Constraints:

  • \(1\le s\).length, \(t\).length \(\le 5\times 10^4\)
  • s and t consists of lowercase English letters

Solution:
We can use hasmap to solve this problem. Basically, we will create two hasmaps for two words and match the keys and values of the hasmaps. If they are equal then it’s an anagram, otherwise not.

def isAnagram(s,t):
  if len(s) != len(t):
    return False 
  
  hash_s, hash_t = {}, {}
  for i in range(len(s)):
    hash_s[s[i]] = 1 + hash_s.get(s[i],0)  # get function collects the key and values.
    hash_t[t[i]] = 1 + hash_t.get(t[i],0)  # if there's no key, 0 is the default value
  
  for c in hash_s:
    if hash_s[c] != hash_t.get(c,0):       # Here, get function ensures there is no 
      return False                         # key error
  return True

s = "anagram"
t = "nagaram"

print(isAnagram(s,t))

u = "rat"

print(isAnagram(s,u))
True
False

Time and Space Complexity:
Time complexity \(\mathcal{O}(m+n)\) where \(m\) and \(n\) are the length of s and t and memory complexity is the same \(\mathcal{O}(m+n)\)

Optimization: Can we solve the problem in \(\mathcal{O}(1)\)? If we assume sort doesn’t require extra space, then

def isAnagram(s,t):
  return sorted(s)== sorted(t)

s= "anagram"
t= "nagaram"

print(isAnagram(s,t))
True

Reference

All my solutions here are based on the solutions found from NeetCode.

Back to top